//****************************************************************************
// 8 bit binary add/sub.
//
// (C) 2013, Ken Chamberlain <kenneth.r.chamberlain@comcast.net>
//
// Feel free to use this code in any project (commercial or not), as long as you
// keep this message, and the copyright notice. This code is provided "as is", 
// without any warranties of any kind. 
// 
//****************************************************************************

//mode == 0 -> add
//mode == 1 -> sub (or cmp)
module accumulator(mode, Ain, Bin, Cin, Dout, Cout, D_zero, D_negative, D_overflow, B_0);

input [7:0] Ain, Bin;
input mode, Cin;

output [7:0] Dout;
output Cout, D_zero, D_negative, D_overflow, B_0;

wire [6:0] carrys;
wire [7:0] bdout;

// binary addition and subtraction accumulator
adder add_bit0(mode, Ain[0], Bin[0],       Cin, bdout[0], carrys[0]);
adder add_bit1(mode, Ain[1], Bin[1], carrys[0], bdout[1], carrys[1]);
adder add_bit2(mode, Ain[2], Bin[2], carrys[1], bdout[2], carrys[2]);
adder add_bit3(mode, Ain[3], Bin[3], carrys[2], bdout[3], carrys[3]);
adder add_bit4(mode, Ain[4], Bin[4], carrys[3], bdout[4], carrys[4]);
adder add_bit5(mode, Ain[5], Bin[5], carrys[4], bdout[5], carrys[5]);
adder add_bit6(mode, Ain[6], Bin[6], carrys[5], bdout[6], carrys[6]);
adder add_bit7(mode, Ain[7], Bin[7], carrys[6], bdout[7], bcout);

//binary only accumulator results
assign Dout = bdout;

//binary only flag results
assign Cout = bcout;
assign D_negative = bdout[7];
assign D_overflow = carrys[6] ^ bcout;
assign D_zero = ~(|bdout[7:0]);

//operand register is zero?
assign B_0 = ~(|Bin[7:0]);

endmodule
