//****************************************************************************
// 8 bit binary comparitor.
//
// (C) 2013, Ken Chamberlain <kenneth.r.chamberlain@comcast.net>
//
// Feel free to use this code in any project (commercial or not), as long as you
// keep this message, and the copyright notice. This code is provided "as is", 
// without any warranties of any kind. 
// 
//****************************************************************************

module compare(Ain, Bin, Cout, D_zero, D_negative);

input [7:0] Ain, Bin;

output D_negative, Cout, D_zero;

wire [6:0] carrys;
wire [7:0] Dout;

//accumulator results
adder add_bit0(1'b1, Ain[0], Bin[0], 1'b1, Dout[0], carrys[0]);
adder add_bit1(1'b1, Ain[1], Bin[1], carrys[0], Dout[1], carrys[1]);
adder add_bit2(1'b1, Ain[2], Bin[2], carrys[1], Dout[2], carrys[2]);
adder add_bit3(1'b1, Ain[3], Bin[3], carrys[2], Dout[3], carrys[3]);
adder add_bit4(1'b1, Ain[4], Bin[4], carrys[3], Dout[4], carrys[4]);
adder add_bit5(1'b1, Ain[5], Bin[5], carrys[4], Dout[5], carrys[5]);
adder add_bit6(1'b1, Ain[6], Bin[6], carrys[5], Dout[6], carrys[6]);
adder add_bit7(1'b1, Ain[7], Bin[7], carrys[6], Dout[7], Cout);

//flag results
assign D_zero = ~(|Dout[7:0]);
assign D_negative = Dout[7];

endmodule
