//****************************************************************************
// C64 memory map decoder.
//
// (C) 2013, Ken Chamberlain <kenneth.r.chamberlain@comcast.net>
//
// Feel free to use this code in any project (commercial or not), as long as you
// keep this message, and the copyright notice. This code is provided "as is", 
// without any warranties of any kind. 
// 
//****************************************************************************

module memmap(GAME, EXROM, hiram, loram, charen, IOSpace, Rom_8, Rom_A, Rom_D, Rom_E);

input GAME, EXROM, hiram, loram, charen;

output IOSpace, Rom_8, Rom_A, Rom_D, Rom_E;

//this decoding enables roms or io in the C64 memory map
assign IOSpace = (hiram | loram | (~hiram & ~loram & ~GAME & EXROM)) & ~(~charen & ~(~hiram & loram & ~GAME & ~EXROM));
assign Rom_8 = (~GAME & EXROM) | (hiram & loram & ~EXROM);
assign Rom_A = (hiram & loram & GAME) | (hiram & loram & ~GAME & ~EXROM) | (hiram & ~loram & ~GAME & ~EXROM);
assign Rom_D = ~charen & ~(~hiram & loram & ~GAME & ~EXROM);
assign Rom_E = hiram | (~GAME & EXROM);

endmodule
