//****************************************************************************
// 256 byte memory. 2 address bus x 2 data byte X 64 deep register
//
// (C) 2013, Ken Chamberlain <kenneth.r.chamberlain@comcast.net>
//
// Feel free to use this code in any project (commercial or not), as long as you
// keep this message, and the copyright notice. This code is provided "as is", 
// without any warranties of any kind. 
// 
//****************************************************************************

module ram256(WCLK, WBYTE, EN, ADD1, ADD2, DI, DO);

input EN;
input WCLK;
input [3:0] WBYTE;
input [5:0] ADD1, ADD2;
input [31:0] DI;
output [31:0] DO;


   // RAM64X1S: 64 x 1 positive edge write, asynchronous read single-port distributed RAM
   //           Virtex-II/II-Pro/4/5, Spartan-3/3E/3A
   // Xilinx HDL Language Template, version 9.1.1i

   RAM64X1S #(
      .INIT(64'h0000000000000000) // Initial contents of RAM
   ) RAM64X1S_inst31 (
      .O(DO[31]),        // 1-bit data output
      .A0(ADD1[0]),      // Address[0] input bit
      .A1(ADD1[1]),      // Address[1] input bit
      .A2(ADD1[2]),      // Address[2] input bit
      .A3(ADD1[3]),      // Address[3] input bit
      .A4(ADD1[4]),      // Address[4] input bit
      .A5(ADD1[5]),      // Address[5] input bit
      .D(DI[31]),        // 1-bit data input
      .WCLK(WCLK),  // Write clock input
      .WE(EN & ~WBYTE[3])       // Write enable input
   );

   // End of RAM64X1S_inst instantiation

   // RAM64X1S: 64 x 1 positive edge write, asynchronous read single-port distributed RAM
   //           Virtex-II/II-Pro/4/5, Spartan-3/3E/3A
   // Xilinx HDL Language Template, version 9.1.1i

   RAM64X1S #(
      .INIT(64'h0000000000000000) // Initial contents of RAM
   ) RAM64X1S_inst30 (
      .O(DO[30]),        // 1-bit data output
      .A0(ADD1[0]),      // Address[0] input bit
      .A1(ADD1[1]),      // Address[1] input bit
      .A2(ADD1[2]),      // Address[2] input bit
      .A3(ADD1[3]),      // Address[3] input bit
      .A4(ADD1[4]),      // Address[4] input bit
      .A5(ADD1[5]),      // Address[5] input bit
      .D(DI[30]),        // 1-bit data input
      .WCLK(WCLK),       // Write clock input
      .WE(EN & ~WBYTE[3])      // Write enable input
   );

   // End of RAM64X1S_inst instantiation

   // RAM64X1S: 64 x 1 positive edge write, asynchronous read single-port distributed RAM
   //           Virtex-II/II-Pro/4/5, Spartan-3/3E/3A
   // Xilinx HDL Language Template, version 9.1.1i

   RAM64X1S #(
      .INIT(64'h0000000000000000) // Initial contents of RAM
   ) RAM64X1S_inst29 (
      .O(DO[29]),        // 1-bit data output
      .A0(ADD1[0]),      // Address[0] input bit
      .A1(ADD1[1]),      // Address[1] input bit
      .A2(ADD1[2]),      // Address[2] input bit
      .A3(ADD1[3]),      // Address[3] input bit
      .A4(ADD1[4]),      // Address[4] input bit
      .A5(ADD1[5]),      // Address[5] input bit
      .D(DI[29]),        // 1-bit data input
      .WCLK(WCLK),  // Write clock input
      .WE(EN & ~WBYTE[3])       // Write enable input
   );

   // End of RAM64X1S_inst instantiation

   // RAM64X1S: 64 x 1 positive edge write, asynchronous read single-port distributed RAM
   //           Virtex-II/II-Pro/4/5, Spartan-3/3E/3A
   // Xilinx HDL Language Template, version 9.1.1i

   RAM64X1S #(
      .INIT(64'h0000000000000000) // Initial contents of RAM
   ) RAM64X1S_inst28 (
      .O(DO[28]),        // 1-bit data output
      .A0(ADD1[0]),      // Address[0] input bit
      .A1(ADD1[1]),      // Address[1] input bit
      .A2(ADD1[2]),      // Address[2] input bit
      .A3(ADD1[3]),      // Address[3] input bit
      .A4(ADD1[4]),      // Address[4] input bit
      .A5(ADD1[5]),      // Address[5] input bit
      .D(DI[28]),        // 1-bit data input
      .WCLK(WCLK),  // Write clock input
      .WE(EN & ~WBYTE[3])       // Write enable input
   );

   // End of RAM64X1S_inst instantiation

   // RAM64X1S: 64 x 1 positive edge write, asynchronous read single-port distributed RAM
   //           Virtex-II/II-Pro/4/5, Spartan-3/3E/3A
   // Xilinx HDL Language Template, version 9.1.1i

   RAM64X1S #(
      .INIT(64'h0000000000000000) // Initial contents of RAM
   ) RAM64X1S_inst27 (
      .O(DO[27]),        // 1-bit data output
      .A0(ADD1[0]),      // Address[0] input bit
      .A1(ADD1[1]),      // Address[1] input bit
      .A2(ADD1[2]),      // Address[2] input bit
      .A3(ADD1[3]),      // Address[3] input bit
      .A4(ADD1[4]),      // Address[4] input bit
      .A5(ADD1[5]),      // Address[5] input bit
      .D(DI[27]),        // 1-bit data input
      .WCLK(WCLK),  // Write clock input
      .WE(EN & ~WBYTE[3])       // Write enable input
   );

   // End of RAM64X1S_inst instantiation

   // RAM64X1S: 64 x 1 positive edge write, asynchronous read single-port distributed RAM
   //           Virtex-II/II-Pro/4/5, Spartan-3/3E/3A
   // Xilinx HDL Language Template, version 9.1.1i

   RAM64X1S #(
      .INIT(64'h0000000000000000) // Initial contents of RAM
   ) RAM64X1S_inst26 (
      .O(DO[26]),        // 1-bit data output
      .A0(ADD1[0]),      // Address[0] input bit
      .A1(ADD1[1]),      // Address[1] input bit
      .A2(ADD1[2]),      // Address[2] input bit
      .A3(ADD1[3]),      // Address[3] input bit
      .A4(ADD1[4]),      // Address[4] input bit
      .A5(ADD1[5]),      // Address[5] input bit
      .D(DI[26]),        // 1-bit data input
      .WCLK(WCLK),  // Write clock input
      .WE(EN & ~WBYTE[3])       // Write enable input
   );

   // End of RAM64X1S_inst instantiation

   // RAM64X1S: 64 x 1 positive edge write, asynchronous read single-port distributed RAM
   //           Virtex-II/II-Pro/4/5, Spartan-3/3E/3A
   // Xilinx HDL Language Template, version 9.1.1i

   RAM64X1S #(
      .INIT(64'h0000000000000000) // Initial contents of RAM
   ) RAM64X1S_inst25 (
      .O(DO[25]),        // 1-bit data output
      .A0(ADD1[0]),      // Address[0] input bit
      .A1(ADD1[1]),      // Address[1] input bit
      .A2(ADD1[2]),      // Address[2] input bit
      .A3(ADD1[3]),      // Address[3] input bit
      .A4(ADD1[4]),      // Address[4] input bit
      .A5(ADD1[5]),      // Address[5] input bit
      .D(DI[25]),        // 1-bit data input
      .WCLK(WCLK),  // Write clock input
      .WE(EN & ~WBYTE[3])       // Write enable input
   );

   // End of RAM64X1S_inst instantiation

   // RAM64X1S: 64 x 1 positive edge write, asynchronous read single-port distributed RAM
   //           Virtex-II/II-Pro/4/5, Spartan-3/3E/3A
   // Xilinx HDL Language Template, version 9.1.1i

   RAM64X1S #(
      .INIT(64'h0000000000000000) // Initial contents of RAM
   ) RAM64X1S_inst24 (
      .O(DO[24]),        // 1-bit data output
      .A0(ADD1[0]),      // Address[0] input bit
      .A1(ADD1[1]),      // Address[1] input bit
      .A2(ADD1[2]),      // Address[2] input bit
      .A3(ADD1[3]),      // Address[3] input bit
      .A4(ADD1[4]),      // Address[4] input bit
      .A5(ADD1[5]),      // Address[5] input bit
      .D(DI[24]),        // 1-bit data input
      .WCLK(WCLK),  // Write clock input
      .WE(EN & ~WBYTE[3])       // Write enable input
   );

   // End of RAM64X1S_inst instantiation



   // RAM64X1S: 64 x 1 positive edge write, asynchronous read single-port distributed RAM
   //           Virtex-II/II-Pro/4/5, Spartan-3/3E/3A
   // Xilinx HDL Language Template, version 9.1.1i

   RAM64X1S #(
      .INIT(64'h0000000000000000) // Initial contents of RAM
   ) RAM64X1S_inst23 (
      .O(DO[23]),        // 1-bit data output
      .A0(ADD1[0]),      // Address[0] input bit
      .A1(ADD1[1]),      // Address[1] input bit
      .A2(ADD1[2]),      // Address[2] input bit
      .A3(ADD1[3]),      // Address[3] input bit
      .A4(ADD1[4]),      // Address[4] input bit
      .A5(ADD1[5]),      // Address[5] input bit
      .D(DI[23]),        // 1-bit data input
      .WCLK(WCLK),  // Write clock input
      .WE(EN & ~WBYTE[2])       // Write enable input
   );

   // End of RAM64X1S_inst instantiation

   // RAM64X1S: 64 x 1 positive edge write, asynchronous read single-port distributed RAM
   //           Virtex-II/II-Pro/4/5, Spartan-3/3E/3A
   // Xilinx HDL Language Template, version 9.1.1i

   RAM64X1S #(
      .INIT(64'h0000000000000000) // Initial contents of RAM
   ) RAM64X1S_inst22 (
      .O(DO[22]),        // 1-bit data output
      .A0(ADD1[0]),      // Address[0] input bit
      .A1(ADD1[1]),      // Address[1] input bit
      .A2(ADD1[2]),      // Address[2] input bit
      .A3(ADD1[3]),      // Address[3] input bit
      .A4(ADD1[4]),      // Address[4] input bit
      .A5(ADD1[5]),      // Address[5] input bit
      .D(DI[22]),        // 1-bit data input
      .WCLK(WCLK),  // Write clock input
      .WE(EN & ~WBYTE[2])       // Write enable input
   );

   // End of RAM64X1S_inst instantiation

   // RAM64X1S: 64 x 1 positive edge write, asynchronous read single-port distributed RAM
   //           Virtex-II/II-Pro/4/5, Spartan-3/3E/3A
   // Xilinx HDL Language Template, version 9.1.1i

   RAM64X1S #(
      .INIT(64'h0000000000000000) // Initial contents of RAM
   ) RAM64X1S_inst21 (
      .O(DO[21]),        // 1-bit data output
      .A0(ADD1[0]),      // Address[0] input bit
      .A1(ADD1[1]),      // Address[1] input bit
      .A2(ADD1[2]),      // Address[2] input bit
      .A3(ADD1[3]),      // Address[3] input bit
      .A4(ADD1[4]),      // Address[4] input bit
      .A5(ADD1[5]),      // Address[5] input bit
      .D(DI[21]),        // 1-bit data input
      .WCLK(WCLK),  // Write clock input
      .WE(EN & ~WBYTE[2])       // Write enable input
   );

   // End of RAM64X1S_inst instantiation

   // RAM64X1S: 64 x 1 positive edge write, asynchronous read single-port distributed RAM
   //           Virtex-II/II-Pro/4/5, Spartan-3/3E/3A
   // Xilinx HDL Language Template, version 9.1.1i

   RAM64X1S #(
      .INIT(64'h0000000000000000) // Initial contents of RAM
   ) RAM64X1S_inst20 (
      .O(DO[20]),        // 1-bit data output
      .A0(ADD1[0]),      // Address[0] input bit
      .A1(ADD1[1]),      // Address[1] input bit
      .A2(ADD1[2]),      // Address[2] input bit
      .A3(ADD1[3]),      // Address[3] input bit
      .A4(ADD1[4]),      // Address[4] input bit
      .A5(ADD1[5]),      // Address[5] input bit
      .D(DI[20]),        // 1-bit data input
      .WCLK(WCLK),  // Write clock input
      .WE(EN & ~WBYTE[2])       // Write enable input
   );

   // End of RAM64X1S_inst instantiation

   // RAM64X1S: 64 x 1 positive edge write, asynchronous read single-port distributed RAM
   //           Virtex-II/II-Pro/4/5, Spartan-3/3E/3A
   // Xilinx HDL Language Template, version 9.1.1i

   RAM64X1S #(
      .INIT(64'h0000000000000000) // Initial contents of RAM
   ) RAM64X1S_inst19 (
      .O(DO[19]),        // 1-bit data output
      .A0(ADD1[0]),      // Address[0] input bit
      .A1(ADD1[1]),      // Address[1] input bit
      .A2(ADD1[2]),      // Address[2] input bit
      .A3(ADD1[3]),      // Address[3] input bit
      .A4(ADD1[4]),      // Address[4] input bit
      .A5(ADD1[5]),      // Address[5] input bit
      .D(DI[19]),        // 1-bit data input
      .WCLK(WCLK),  // Write clock input
      .WE(EN & ~WBYTE[2])       // Write enable input
   );

   // End of RAM64X1S_inst instantiation

   // RAM64X1S: 64 x 1 positive edge write, asynchronous read single-port distributed RAM
   //           Virtex-II/II-Pro/4/5, Spartan-3/3E/3A
   // Xilinx HDL Language Template, version 9.1.1i

   RAM64X1S #(
      .INIT(64'h0000000000000000) // Initial contents of RAM
   ) RAM64X1S_inst18 (
      .O(DO[18]),        // 1-bit data output
      .A0(ADD1[0]),      // Address[0] input bit
      .A1(ADD1[1]),      // Address[1] input bit
      .A2(ADD1[2]),      // Address[2] input bit
      .A3(ADD1[3]),      // Address[3] input bit
      .A4(ADD1[4]),      // Address[4] input bit
      .A5(ADD1[5]),      // Address[5] input bit
      .D(DI[18]),        // 1-bit data input
      .WCLK(WCLK),  // Write clock input
      .WE(EN & ~WBYTE[2])       // Write enable input
   );

   // End of RAM64X1S_inst instantiation

   // RAM64X1S: 64 x 1 positive edge write, asynchronous read single-port distributed RAM
   //           Virtex-II/II-Pro/4/5, Spartan-3/3E/3A
   // Xilinx HDL Language Template, version 9.1.1i

   RAM64X1S #(
      .INIT(64'h0000000000000000) // Initial contents of RAM
   ) RAM64X1S_inst17 (
      .O(DO[17]),        // 1-bit data output
      .A0(ADD1[0]),      // Address[0] input bit
      .A1(ADD1[1]),      // Address[1] input bit
      .A2(ADD1[2]),      // Address[2] input bit
      .A3(ADD1[3]),      // Address[3] input bit
      .A4(ADD1[4]),      // Address[4] input bit
      .A5(ADD1[5]),      // Address[5] input bit
      .D(DI[17]),        // 1-bit data input
      .WCLK(WCLK),  // Write clock input
      .WE(EN & ~WBYTE[2])       // Write enable input
   );

   // End of RAM64X1S_inst instantiation

   // RAM64X1S: 64 x 1 positive edge write, asynchronous read single-port distributed RAM
   //           Virtex-II/II-Pro/4/5, Spartan-3/3E/3A
   // Xilinx HDL Language Template, version 9.1.1i

   RAM64X1S #(
      .INIT(64'h0000000000000000) // Initial contents of RAM
   ) RAM64X1S_inst16 (
      .O(DO[16]),        // 1-bit data output
      .A0(ADD1[0]),      // Address[0] input bit
      .A1(ADD1[1]),      // Address[1] input bit
      .A2(ADD1[2]),      // Address[2] input bit
      .A3(ADD1[3]),      // Address[3] input bit
      .A4(ADD1[4]),      // Address[4] input bit
      .A5(ADD1[5]),      // Address[5] input bit
      .D(DI[16]),        // 1-bit data input
      .WCLK(WCLK),  // Write clock input
      .WE(EN & ~WBYTE[2])       // Write enable input
   );

   // End of RAM64X1S_inst instantiation





   // RAM64X1S: 64 x 1 positive edge write, asynchronous read single-port distributed RAM
   //           Virtex-II/II-Pro/4/5, Spartan-3/3E/3A
   // Xilinx HDL Language Template, version 9.1.1i

   RAM64X1S #(
      .INIT(64'h0000000000000000) // Initial contents of RAM
   ) RAM64X1S_inst15 (
      .O(DO[15]),        // 1-bit data output
      .A0(ADD2[0]),      // Address[0] input bit
      .A1(ADD2[1]),      // Address[1] input bit
      .A2(ADD2[2]),      // Address[2] input bit
      .A3(ADD2[3]),      // Address[3] input bit
      .A4(ADD2[4]),      // Address[4] input bit
      .A5(ADD2[5]),      // Address[5] input bit
      .D(DI[15]),        // 1-bit data input
      .WCLK(WCLK),  // Write clock input
      .WE(EN & ~WBYTE[1])       // Write enable input
   );

   // End of RAM64X1S_inst instantiation

   // RAM64X1S: 64 x 1 positive edge write, asynchronous read single-port distributed RAM
   //           Virtex-II/II-Pro/4/5, Spartan-3/3E/3A
   // Xilinx HDL Language Template, version 9.1.1i

   RAM64X1S #(
      .INIT(64'h0000000000000000) // Initial contents of RAM
   ) RAM64X1S_inst14 (
      .O(DO[14]),        // 1-bit data output
      .A0(ADD2[0]),      // Address[0] input bit
      .A1(ADD2[1]),      // Address[1] input bit
      .A2(ADD2[2]),      // Address[2] input bit
      .A3(ADD2[3]),      // Address[3] input bit
      .A4(ADD2[4]),      // Address[4] input bit
      .A5(ADD2[5]),      // Address[5] input bit
      .D(DI[14]),        // 1-bit data input
      .WCLK(WCLK),  // Write clock input
      .WE(EN & ~WBYTE[1])       // Write enable input
   );

   // End of RAM64X1S_inst instantiation

   // RAM64X1S: 64 x 1 positive edge write, asynchronous read single-port distributed RAM
   //           Virtex-II/II-Pro/4/5, Spartan-3/3E/3A
   // Xilinx HDL Language Template, version 9.1.1i

   RAM64X1S #(
      .INIT(64'h0000000000000000) // Initial contents of RAM
   ) RAM64X1S_inst13 (
      .O(DO[13]),        // 1-bit data output
      .A0(ADD2[0]),      // Address[0] input bit
      .A1(ADD2[1]),      // Address[1] input bit
      .A2(ADD2[2]),      // Address[2] input bit
      .A3(ADD2[3]),      // Address[3] input bit
      .A4(ADD2[4]),      // Address[4] input bit
      .A5(ADD2[5]),      // Address[5] input bit
      .D(DI[13]),        // 1-bit data input
      .WCLK(WCLK),  // Write clock input
      .WE(EN & ~WBYTE[1])       // Write enable input
   );

   // End of RAM64X1S_inst instantiation

   // RAM64X1S: 64 x 1 positive edge write, asynchronous read single-port distributed RAM
   //           Virtex-II/II-Pro/4/5, Spartan-3/3E/3A
   // Xilinx HDL Language Template, version 9.1.1i

   RAM64X1S #(
      .INIT(64'h0000000000000000) // Initial contents of RAM
   ) RAM64X1S_inst12 (
      .O(DO[12]),        // 1-bit data output
      .A0(ADD2[0]),      // Address[0] input bit
      .A1(ADD2[1]),      // Address[1] input bit
      .A2(ADD2[2]),      // Address[2] input bit
      .A3(ADD2[3]),      // Address[3] input bit
      .A4(ADD2[4]),      // Address[4] input bit
      .A5(ADD2[5]),      // Address[5] input bit
      .D(DI[12]),        // 1-bit data input
      .WCLK(WCLK),  // Write clock input
      .WE(EN & ~WBYTE[1])       // Write enable input
   );

   // End of RAM64X1S_inst instantiation

   // RAM64X1S: 64 x 1 positive edge write, asynchronous read single-port distributed RAM
   //           Virtex-II/II-Pro/4/5, Spartan-3/3E/3A
   // Xilinx HDL Language Template, version 9.1.1i

   RAM64X1S #(
      .INIT(64'h0000000000000000) // Initial contents of RAM
   ) RAM64X1S_inst11 (
      .O(DO[11]),        // 1-bit data output
      .A0(ADD2[0]),      // Address[0] input bit
      .A1(ADD2[1]),      // Address[1] input bit
      .A2(ADD2[2]),      // Address[2] input bit
      .A3(ADD2[3]),      // Address[3] input bit
      .A4(ADD2[4]),      // Address[4] input bit
      .A5(ADD2[5]),      // Address[5] input bit
      .D(DI[11]),        // 1-bit data input
      .WCLK(WCLK),  // Write clock input
      .WE(EN & ~WBYTE[1])       // Write enable input
   );

   // End of RAM64X1S_inst instantiation

   // RAM64X1S: 64 x 1 positive edge write, asynchronous read single-port distributed RAM
   //           Virtex-II/II-Pro/4/5, Spartan-3/3E/3A
   // Xilinx HDL Language Template, version 9.1.1i

   RAM64X1S #(
      .INIT(64'h0000000000000000) // Initial contents of RAM
   ) RAM64X1S_inst10 (
      .O(DO[10]),        // 1-bit data output
      .A0(ADD2[0]),      // Address[0] input bit
      .A1(ADD2[1]),      // Address[1] input bit
      .A2(ADD2[2]),      // Address[2] input bit
      .A3(ADD2[3]),      // Address[3] input bit
      .A4(ADD2[4]),      // Address[4] input bit
      .A5(ADD2[5]),      // Address[5] input bit
      .D(DI[10]),        // 1-bit data input
      .WCLK(WCLK),  // Write clock input
      .WE(EN & ~WBYTE[1])       // Write enable input
   );

   // End of RAM64X1S_inst instantiation

   // RAM64X1S: 64 x 1 positive edge write, asynchronous read single-port distributed RAM
   //           Virtex-II/II-Pro/4/5, Spartan-3/3E/3A
   // Xilinx HDL Language Template, version 9.1.1i

   RAM64X1S #(
      .INIT(64'h0000000000000000) // Initial contents of RAM
   ) RAM64X1S_inst9 (
      .O(DO[9]),        // 1-bit data output
      .A0(ADD2[0]),      // Address[0] input bit
      .A1(ADD2[1]),      // Address[1] input bit
      .A2(ADD2[2]),      // Address[2] input bit
      .A3(ADD2[3]),      // Address[3] input bit
      .A4(ADD2[4]),      // Address[4] input bit
      .A5(ADD2[5]),      // Address[5] input bit
      .D(DI[9]),        // 1-bit data input
      .WCLK(WCLK),  // Write clock input
      .WE(EN & ~WBYTE[1])       // Write enable input
   );

   // End of RAM64X1S_inst instantiation

   // RAM64X1S: 64 x 1 positive edge write, asynchronous read single-port distributed RAM
   //           Virtex-II/II-Pro/4/5, Spartan-3/3E/3A
   // Xilinx HDL Language Template, version 9.1.1i

   RAM64X1S #(
      .INIT(64'h0000000000000000) // Initial contents of RAM
   ) RAM64X1S_inst8 (
      .O(DO[8]),        // 1-bit data output
      .A0(ADD2[0]),      // Address[0] input bit
      .A1(ADD2[1]),      // Address[1] input bit
      .A2(ADD2[2]),      // Address[2] input bit
      .A3(ADD2[3]),      // Address[3] input bit
      .A4(ADD2[4]),      // Address[4] input bit
      .A5(ADD2[5]),      // Address[5] input bit
      .D(DI[8]),        // 1-bit data input
      .WCLK(WCLK),  // Write clock input
      .WE(EN & ~WBYTE[1])       // Write enable input
   );

   // End of RAM64X1S_inst instantiation




   // RAM64X1S: 64 x 1 positive edge write, asynchronous read single-port distributed RAM
   //           Virtex-II/II-Pro/4/5, Spartan-3/3E/3A
   // Xilinx HDL Language Template, version 9.1.1i

   RAM64X1S #(
      .INIT(64'h0000000000000000) // Initial contents of RAM
   ) RAM64X1S_inst7 (
      .O(DO[7]),        // 1-bit data output
      .A0(ADD2[0]),      // Address[0] input bit
      .A1(ADD2[1]),      // Address[1] input bit
      .A2(ADD2[2]),      // Address[2] input bit
      .A3(ADD2[3]),      // Address[3] input bit
      .A4(ADD2[4]),      // Address[4] input bit
      .A5(ADD2[5]),      // Address[5] input bit
      .D(DI[7]),        // 1-bit data input
      .WCLK(WCLK),  // Write clock input
      .WE(EN & ~WBYTE[0])       // Write enable input
   );

   // End of RAM64X1S_inst instantiation

   // RAM64X1S: 64 x 1 positive edge write, asynchronous read single-port distributed RAM
   //           Virtex-II/II-Pro/4/5, Spartan-3/3E/3A
   // Xilinx HDL Language Template, version 9.1.1i

   RAM64X1S #(
      .INIT(64'h0000000000000000) // Initial contents of RAM
   ) RAM64X1S_inst6 (
      .O(DO[6]),        // 1-bit data output
      .A0(ADD2[0]),      // Address[0] input bit
      .A1(ADD2[1]),      // Address[1] input bit
      .A2(ADD2[2]),      // Address[2] input bit
      .A3(ADD2[3]),      // Address[3] input bit
      .A4(ADD2[4]),      // Address[4] input bit
      .A5(ADD2[5]),      // Address[5] input bit
      .D(DI[6]),        // 1-bit data input
      .WCLK(WCLK),  // Write clock input
      .WE(EN & ~WBYTE[0])       // Write enable input
   );

   // End of RAM64X1S_inst instantiation

   // RAM64X1S: 64 x 1 positive edge write, asynchronous read single-port distributed RAM
   //           Virtex-II/II-Pro/4/5, Spartan-3/3E/3A
   // Xilinx HDL Language Template, version 9.1.1i

   RAM64X1S #(
      .INIT(64'h0000000000000000) // Initial contents of RAM
   ) RAM64X1S_inst5 (
      .O(DO[5]),        // 1-bit data output
      .A0(ADD2[0]),      // Address[0] input bit
      .A1(ADD2[1]),      // Address[1] input bit
      .A2(ADD2[2]),      // Address[2] input bit
      .A3(ADD2[3]),      // Address[3] input bit
      .A4(ADD2[4]),      // Address[4] input bit
      .A5(ADD2[5]),      // Address[5] input bit
      .D(DI[5]),        // 1-bit data input
      .WCLK(WCLK),  // Write clock input
      .WE(EN & ~WBYTE[0])       // Write enable input
   );

   // End of RAM64X1S_inst instantiation

   // RAM64X1S: 64 x 1 positive edge write, asynchronous read single-port distributed RAM
   //           Virtex-II/II-Pro/4/5, Spartan-3/3E/3A
   // Xilinx HDL Language Template, version 9.1.1i

   RAM64X1S #(
      .INIT(64'h0000000000000000) // Initial contents of RAM
   ) RAM64X1S_inst4 (
      .O(DO[4]),        // 1-bit data output
      .A0(ADD2[0]),      // Address[0] input bit
      .A1(ADD2[1]),      // Address[1] input bit
      .A2(ADD2[2]),      // Address[2] input bit
      .A3(ADD2[3]),      // Address[3] input bit
      .A4(ADD2[4]),      // Address[4] input bit
      .A5(ADD2[5]),      // Address[5] input bit
      .D(DI[4]),        // 1-bit data input
      .WCLK(WCLK),  // Write clock input
      .WE(EN & ~WBYTE[0])       // Write enable input
   );

   // End of RAM64X1S_inst instantiation

   // RAM64X1S: 64 x 1 positive edge write, asynchronous read single-port distributed RAM
   //           Virtex-II/II-Pro/4/5, Spartan-3/3E/3A
   // Xilinx HDL Language Template, version 9.1.1i

   RAM64X1S #(
      .INIT(64'h0000000000000000) // Initial contents of RAM
   ) RAM64X1S_inst3 (
      .O(DO[3]),        // 1-bit data output
      .A0(ADD2[0]),      // Address[0] input bit
      .A1(ADD2[1]),      // Address[1] input bit
      .A2(ADD2[2]),      // Address[2] input bit
      .A3(ADD2[3]),      // Address[3] input bit
      .A4(ADD2[4]),      // Address[4] input bit
      .A5(ADD2[5]),      // Address[5] input bit
      .D(DI[3]),        // 1-bit data input
      .WCLK(WCLK),  // Write clock input
      .WE(EN & ~WBYTE[0])       // Write enable input
   );

   // End of RAM64X1S_inst instantiation

   // RAM64X1S: 64 x 1 positive edge write, asynchronous read single-port distributed RAM
   //           Virtex-II/II-Pro/4/5, Spartan-3/3E/3A
   // Xilinx HDL Language Template, version 9.1.1i

   RAM64X1S #(
      .INIT(64'h0000000000000000) // Initial contents of RAM
   ) RAM64X1S_inst2 (
      .O(DO[2]),        // 1-bit data output
      .A0(ADD2[0]),      // Address[0] input bit
      .A1(ADD2[1]),      // Address[1] input bit
      .A2(ADD2[2]),      // Address[2] input bit
      .A3(ADD2[3]),      // Address[3] input bit
      .A4(ADD2[4]),      // Address[4] input bit
      .A5(ADD2[5]),      // Address[5] input bit
      .D(DI[2]),        // 1-bit data input
      .WCLK(WCLK),  // Write clock input
      .WE(EN & ~WBYTE[0])       // Write enable input
   );

   // End of RAM64X1S_inst instantiation

   // RAM64X1S: 64 x 1 positive edge write, asynchronous read single-port distributed RAM
   //           Virtex-II/II-Pro/4/5, Spartan-3/3E/3A
   // Xilinx HDL Language Template, version 9.1.1i

   RAM64X1S #(
      .INIT(64'h0000000000000000) // Initial contents of RAM
   ) RAM64X1S_inst1 (
      .O(DO[1]),        // 1-bit data output
      .A0(ADD2[0]),      // Address[0] input bit
      .A1(ADD2[1]),      // Address[1] input bit
      .A2(ADD2[2]),      // Address[2] input bit
      .A3(ADD2[3]),      // Address[3] input bit
      .A4(ADD2[4]),      // Address[4] input bit
      .A5(ADD2[5]),      // Address[5] input bit
      .D(DI[1]),        // 1-bit data input
      .WCLK(WCLK),  // Write clock input
      .WE(EN & ~WBYTE[0])       // Write enable input
   );

   // End of RAM64X1S_inst instantiation

   // RAM64X1S: 64 x 1 positive edge write, asynchronous read single-port distributed RAM
   //           Virtex-II/II-Pro/4/5, Spartan-3/3E/3A
   // Xilinx HDL Language Template, version 9.1.1i

   RAM64X1S #(
      .INIT(64'h0000000000000000) // Initial contents of RAM
   ) RAM64X1S_inst0 (
      .O(DO[0]),        // 1-bit data output
      .A0(ADD2[0]),      // Address[0] input bit
      .A1(ADD2[1]),      // Address[1] input bit
      .A2(ADD2[2]),      // Address[2] input bit
      .A3(ADD2[3]),      // Address[3] input bit
      .A4(ADD2[4]),      // Address[4] input bit
      .A5(ADD2[5]),      // Address[5] input bit
      .D(DI[0]),        // 1-bit data input
      .WCLK(WCLK),  // Write clock input
      .WE(EN & ~WBYTE[0])       // Write enable input
   );

   // End of RAM64X1S_inst instantiation

endmodule

