//****************************************************************************
// Peripheral register decoder.
//
// (C) 2013, Ken Chamberlain <kenneth.r.chamberlain@comcast.net>
//
// Feel free to use this code in any project (commercial or not), as long as you
// keep this message, and the copyright notice. This code is provided "as is", 
// without any warranties of any kind. 
// 
//****************************************************************************

//`define mouser

module register_decoder(aLower, dAB);

input [5:0] aLower;

`ifdef mouser
output [47:0] dAB;
`else
output [46:0] dAB;
`endif

//this decoding is done here to save space throughout the chip so not every
//io device will bave to have its own register decoder...
assign dAB[0] =    ~aLower[5] &   ~aLower[4] &   ~aLower[3] &   ~aLower[2] &   ~aLower[1] &   ~aLower[0];
assign dAB[1] =    ~aLower[5] &   ~aLower[4] &   ~aLower[3] &   ~aLower[2] &   ~aLower[1] &    aLower[0];
assign dAB[2] =    ~aLower[5] &   ~aLower[4] &   ~aLower[3] &   ~aLower[2] &    aLower[1] &   ~aLower[0];
assign dAB[3] =    ~aLower[5] &   ~aLower[4] &   ~aLower[3] &   ~aLower[2] &    aLower[1] &    aLower[0];
assign dAB[4] =    ~aLower[5] &   ~aLower[4] &   ~aLower[3] &    aLower[2] &   ~aLower[1] &   ~aLower[0];
assign dAB[5] =    ~aLower[5] &   ~aLower[4] &   ~aLower[3] &    aLower[2] &   ~aLower[1] &    aLower[0];
assign dAB[6] =    ~aLower[5] &   ~aLower[4] &   ~aLower[3] &    aLower[2] &    aLower[1] &   ~aLower[0];
assign dAB[7] =    ~aLower[5] &   ~aLower[4] &   ~aLower[3] &    aLower[2] &    aLower[1] &    aLower[0];
assign dAB[8] =    ~aLower[5] &   ~aLower[4] &    aLower[3] &   ~aLower[2] &   ~aLower[1] &   ~aLower[0];
assign dAB[9] =    ~aLower[5] &   ~aLower[4] &    aLower[3] &   ~aLower[2] &   ~aLower[1] &    aLower[0];
assign dAB[10] =   ~aLower[5] &   ~aLower[4] &    aLower[3] &   ~aLower[2] &    aLower[1] &   ~aLower[0];
assign dAB[11] =   ~aLower[5] &   ~aLower[4] &    aLower[3] &   ~aLower[2] &    aLower[1] &    aLower[0];
assign dAB[12] =   ~aLower[5] &   ~aLower[4] &    aLower[3] &    aLower[2] &   ~aLower[1] &   ~aLower[0];
assign dAB[13] =   ~aLower[5] &   ~aLower[4] &    aLower[3] &    aLower[2] &   ~aLower[1] &    aLower[0];
assign dAB[14] =   ~aLower[5] &   ~aLower[4] &    aLower[3] &    aLower[2] &    aLower[1] &   ~aLower[0];
assign dAB[15] =   ~aLower[5] &   ~aLower[4] &    aLower[3] &    aLower[2] &    aLower[1] &    aLower[0];
assign dAB[16] =   ~aLower[5] &    aLower[4] &   ~aLower[3] &   ~aLower[2] &   ~aLower[1] &   ~aLower[0];
assign dAB[17] =   ~aLower[5] &    aLower[4] &   ~aLower[3] &   ~aLower[2] &   ~aLower[1] &    aLower[0];
assign dAB[18] =   ~aLower[5] &    aLower[4] &   ~aLower[3] &   ~aLower[2] &    aLower[1] &   ~aLower[0];
assign dAB[19] =   ~aLower[5] &    aLower[4] &   ~aLower[3] &   ~aLower[2] &    aLower[1] &    aLower[0];
assign dAB[20] =   ~aLower[5] &    aLower[4] &   ~aLower[3] &    aLower[2] &   ~aLower[1] &   ~aLower[0];
assign dAB[21] =   ~aLower[5] &    aLower[4] &   ~aLower[3] &    aLower[2] &   ~aLower[1] &    aLower[0];
assign dAB[22] =   ~aLower[5] &    aLower[4] &   ~aLower[3] &    aLower[2] &    aLower[1] &   ~aLower[0];
assign dAB[23] =   ~aLower[5] &    aLower[4] &   ~aLower[3] &    aLower[2] &    aLower[1] &    aLower[0];
assign dAB[24] =   ~aLower[5] &    aLower[4] &    aLower[3] &   ~aLower[2] &   ~aLower[1] &   ~aLower[0];
assign dAB[25] =   ~aLower[5] &    aLower[4] &    aLower[3] &   ~aLower[2] &   ~aLower[1] &    aLower[0];
assign dAB[26] =   ~aLower[5] &    aLower[4] &    aLower[3] &   ~aLower[2] &    aLower[1] &   ~aLower[0];
assign dAB[27] =   ~aLower[5] &    aLower[4] &    aLower[3] &   ~aLower[2] &    aLower[1] &    aLower[0];
assign dAB[28] =   ~aLower[5] &    aLower[4] &    aLower[3] &    aLower[2] &   ~aLower[1] &   ~aLower[0];
assign dAB[29] =   ~aLower[5] &    aLower[4] &    aLower[3] &    aLower[2] &   ~aLower[1] &    aLower[0];
assign dAB[30] =   ~aLower[5] &    aLower[4] &    aLower[3] &    aLower[2] &    aLower[1] &   ~aLower[0];
assign dAB[31] =   ~aLower[5] &    aLower[4] &    aLower[3] &    aLower[2] &    aLower[1] &    aLower[0];
assign dAB[32] =    aLower[5] &   ~aLower[4] &   ~aLower[3] &   ~aLower[2] &   ~aLower[1] &   ~aLower[0];
assign dAB[33] =    aLower[5] &   ~aLower[4] &   ~aLower[3] &   ~aLower[2] &   ~aLower[1] &    aLower[0];
assign dAB[34] =    aLower[5] &   ~aLower[4] &   ~aLower[3] &   ~aLower[2] &    aLower[1] &   ~aLower[0];
assign dAB[35] =    aLower[5] &   ~aLower[4] &   ~aLower[3] &   ~aLower[2] &    aLower[1] &    aLower[0];
assign dAB[36] =    aLower[5] &   ~aLower[4] &   ~aLower[3] &    aLower[2] &   ~aLower[1] &   ~aLower[0];
assign dAB[37] =    aLower[5] &   ~aLower[4] &   ~aLower[3] &    aLower[2] &   ~aLower[1] &    aLower[0];
assign dAB[38] =    aLower[5] &   ~aLower[4] &   ~aLower[3] &    aLower[2] &    aLower[1] &   ~aLower[0];
assign dAB[39] =    aLower[5] &   ~aLower[4] &   ~aLower[3] &    aLower[2] &    aLower[1] &    aLower[0];
assign dAB[40] =    aLower[5] &   ~aLower[4] &    aLower[3] &   ~aLower[2] &   ~aLower[1] &   ~aLower[0];
assign dAB[41] =    aLower[5] &   ~aLower[4] &    aLower[3] &   ~aLower[2] &   ~aLower[1] &    aLower[0];
assign dAB[42] =    aLower[5] &   ~aLower[4] &    aLower[3] &   ~aLower[2] &    aLower[1] &   ~aLower[0];
assign dAB[43] =    aLower[5] &   ~aLower[4] &    aLower[3] &   ~aLower[2] &    aLower[1] &    aLower[0];
assign dAB[44] =    aLower[5] &   ~aLower[4] &    aLower[3] &    aLower[2] &   ~aLower[1] &   ~aLower[0];
assign dAB[45] =    aLower[5] &   ~aLower[4] &    aLower[3] &    aLower[2] &   ~aLower[1] &    aLower[0];
assign dAB[46] =    aLower[5] &   ~aLower[4] &    aLower[3] &    aLower[2] &    aLower[1] &   ~aLower[0];
`ifdef mouser
assign dAB[47] =    aLower[5] &   ~aLower[4] &    aLower[3] &    aLower[2] &    aLower[1] &    aLower[0];
`endif

endmodule
